\documentclass[t,xcolor={usenames,dvipsnames}, mathserif]{beamer}


\newcommand{\authornames}{Jochen Sautter \and Fabian Gloeckle}
\newcommand{\authorshortnames}{J. Sautter \and F. Gloeckle}
\newcommand{\lecturetitle}{Lecture 8: Recurrent Neural Networks\\{\small{Tuesday, December 12, 2017}}}
\newcommand{\shortlecturetitle}{Lecture 8: RNNs}

\usepackage{beamersetup}
\usepackage{packages}
\usepackage{notation}
\usepackage{listings}
\usepackage[utf8]{inputenc}


\AtBeginSection{
	\myframe{Lecture Overview}{
		\tableofcontents[currentsection,hideallsubsections]
	}
}

\begin{document}
\input{title_slide}




%-----------------------------------------------------------------------
\myframe{Lecture Overview}{
\tableofcontents[hideallsubsections]
}
%-----------------------------------------------------------------------

\section{Long term dependencies}
\begin{frame}[t]{The problem of long term dependencies}
  Loriot, \textit{Die Bundestagsrede}:
  
  \begin{quote}
  Meine Damen und Herren! Politik bedeutet, und davon sollte man ausgehen, das ist doch, ohne darum herum zu reden, in Anbetracht der Situation, in der wir uns befinden. Ich kann meinen politischen Standpunkt in wenigen Worten zusammenfassen: Erstens das Selbstverständnis unter der Voraussetzung, zweitens und das ist es was wir unseren Wählern schuldig sind, drittens die konzentrierte Beinhaltung als Kernstück eines zukunftweisenden Parteiprogramms.    
  \end{quote}

  \small{from: \url{http://www.cdu-sievershuetten.de/Loriot_Bundestagsrede.pdf}}

\end{frame}

\begin{frame}[t]{The problem of long term dependencies}
  english word joke, double meaning
  \begin{block}{Take-away}
    Long term interactions need to be taken into account – don't solve the problem locally!
  \end{block}
\end{frame}

\begin{frame}[t]{Reasons – informally}
  \begin{itemize}
  \item Information morphing:
    \begin{columns}[T]
     \begin{column}[T]{5cm}
       \includegraphics[height=2cm]{ch10/102crop.png}
     \end{column}
     \begin{column}[T]{5cm}
       \includegraphics[height=2cm]{ch10/102crop.png}
     \end{column}
    \end{columns}
  \item relevent information from earlier timesteps does not survive unchanged: affine-linear transformations + nonlinearity
  \item in principle, RNNs could use units just to pass through information
  \item but: learning such weights is hard!
\end{itemize}
\end{frame}

\begin{frame}[t]{Reasons – technically}
\begin{itemize}
\item problem of vanishing and exploding gradients
\item temporal weight sharing: same matrix $W$
\item consider (complex) diagonalization of weight matrix:
\[
  W = Q
  \begin{pmatrix}
    \lambda_1 & & \\
    & \ddots & \\
    & & \lambda_n
  \end{pmatrix} Q^{-1}
  \implies
  W^r = Q
  \begin{pmatrix}
    \lambda_1^r & & \\
    & \ddots & \\
    & & \lambda_n^r
  \end{pmatrix} Q^{-1}
  \]
\item $\lambda_i < 1$: component vanishes \\
  $\lambda_i > 1$: component explodes
\item same effect in backward pass: good weights untrainable
\item in MLPs: weights not shared across layers: independent variables
\end{itemize}
\end{frame}

\begin{frame}[t]{Reasons – technically}
  \includegraphics[height=6cm]{ch10/1015.png}
  repeated composition of an affine linear layer witn $\tanh$-nonlinearity
\end{frame}

%% \begin{frame}[t]{Problem: Long term dependencies}
%% \begin{itemize}
%% \item Examples from \url{http://karpathy.github.io/2015/05/21/rnn-effectiveness/}
%% \item tyntd-iafhatawiaoihrdemot  lytdws  e ,tfti, astai f ogoh eoase rrranbyne 'nhthnee e 
%%   plia tklrgd t o idoe ns,smtt   h ne etie h,hregtrs nigtike,aoaenns lng
%% \item "Tmont thithey" fomesscerliund
%% Keushey. Thom here
%% sheulke, anmerenith ol sivh I lalterthend Bleipile shuwy fil on aseterlome
%% coaniogennc Phe lism thond hon at. MeiDimorotion in ther thize."
%% \item we counter. He stutn co des. His stanted out one ofler that concossions and was 
%%   to gearang reay Jotrets and with fre colt otf paitt thin wall. Which das stimn
%% \item ...
%% \item "Why do what that day," replied Natasha, and wishing to himself the fact the
%% princess, Princess Mary was easier, fed in had oftened him.
%% Pierre aking his soul came to the packs and drove up his father-in-law women.
%% \end{itemize}
%% \end{frame}

%% \begin{frame}[fragile,t]{Problem: Long term dependencies}
%% Examples from \url{http://karpathy.github.io/2015/05/21/rnn-effectiveness/}:
%% \begin{lstlisting}[frame=single]
%% /*
%%  * Increment the size file of the new incorrect UI_FILTER group information
%%  * of the size generatively.
%%  */
%% static int indicate_policy(void)
%% {
%%   int error;
%%   if (fd == MARN_EPT) {
%%     /*
%%      * The kernel blank will coeld it to userspace.
%%      */
%%     if (ss->segment < mem_total)
%%       unblock_graph_and_set_blocked();
%%     else
%%       ret = 1;
%%     goto bail;
%%   }
%%   segaddr = in_SB(in.addr);
%%   selector = seg / 16;
%%   setup_works = true;
%%   for (i = 0; i < blocks; i++) {
%%     seq = buf[i++];
%%     bpf = bd->bd.next + i * search;
%%     if (fd) {
%%       current = blocked;
%%     }
%%   }
%%   rw->name = "Getjbbregs";
%%   bprm_self_clearl(&iv->version);
%%   regs->new = blocks[(BPF_STATS << info->historidac)] | PFMR_CLOBATHINC_SECONDS << 12;
%%   return segtable;
%% }
%% \end{lstlisting}
%% \end{frame}

\section{Propopsed solutions}
\begin{frame}[t]{Propopsed solutions: echo state networks}
  echo state networks: large fixed RNN, only train output layer

  \includegraphics[height=6cm]{images/esn.png}

  \small{image credit: Herbert Jaeger, from \url{http://www.scholarpedia.org/article/Echo_state_network}}
\end{frame}

\begin{frame}[t]{Propopsed solutions: skip connections}
  \begin{itemize}
  \item add skip connections:
    \begin{columns}[T]
      \begin{column}[T]{5cm}
        \includegraphics[height=2cm]{ch10/102crop.png}
      \end{column}
      \begin{column}[T]{5cm}
        \includegraphics[height=2cm]{ch10/102crop.png}
      \end{column}
    \end{columns}
    
    \textit{allows} units to deal with longer scales
  \item replace short-term by long-term connections: \\
    \textit{forces} units to deal with longer scales
  \end{itemize}
\end{frame}


\begin{frame}[t]{Proposed solutions: leaky units}
  \begin{itemize}
  \item leaky units: introduce linear self-connection of units
    \includegraphics[height=2cm]{ch10/102crop.png}
  \item mainly remember last state
  \item just apply updates
  \item such units behave like running averages:
    \[
    \mu^{(t)} = \alpha \mu^{(t-1)} + (1 - \alpha) v^{(t)}
    \]
  \item network can operate on longer timescales, accumulate information
\end{itemize}
\end{frame}

\begin{frame}[t]{Memory heuristic}
  \includegraphics[height=4cm]{images/carter-notes.jpg}
  
  \small{from: \url{https://www.archives.gov/historical-docs/todays-doc/index.html?dod-date=1006}}
  \begin{block}{Memory heuristic}
    RNNs should have a state (internal memory) they can selectively read and update.
  \end{block}
\end{frame}


\section{LSTMs}

\begin{frame}[t]{LSTMs (1997)}
  \begin{itemize}
    \item ``long short-term memory''
    \item implement memory heuristic directly
    \item make self-connection weight trainable and context-dependent
    \item not only accumulate information, but also forget
  \end{itemize}
\end{frame}

\begin{frame}[c]{LSTM cell}
  \includegraphics[height=4cm]{images/lstm0.png}
  \includegraphics[height=1.5cm]{images/lstm1.png}
  
  \small{image credit: Christopher Olah, \url{http://colah.github.io/posts/2015-08-Understanding-LSTMs/}}
\end{frame}

\begin{frame}[c]{LSTM - cell state}
  \includegraphics[height=5cm]{images/lstm2.png}

  \small{image credit: Christopher Olah, \url{http://colah.github.io/posts/2015-08-Understanding-LSTMs/}}
\end{frame}

\begin{frame}[c]{LSTM - forget gate}
  \includegraphics[height=4cm]{images/lstm3.png}

  \small{image credit: Christopher Olah, \url{http://colah.github.io/posts/2015-08-Understanding-LSTMs/}}
\end{frame}

\begin{frame}[c]{LSTM - input gate and candidate value}
  \includegraphics[height=3.8cm]{images/lstm4.png}

  \small{image credit: Christopher Olah, \url{http://colah.github.io/posts/2015-08-Understanding-LSTMs/}}
\end{frame}

\begin{frame}[c]{LSTM - update}
  \includegraphics[height=4cm]{images/lstm5.png}

  where $\ast$ denotes element-wise multiplcation \\

  \small{image credit: Christopher Olah, \url{http://colah.github.io/posts/2015-08-Understanding-LSTMs/}}
\end{frame}

\begin{frame}[c]{LSTM - output}
  \includegraphics[height=4cm]{images/lstm6.png}

  where $\ast$ denotes element-wise multiplcation \\

  \small{image credit: Christopher Olah, \url{http://colah.github.io/posts/2015-08-Understanding-LSTMs/}}
\end{frame}

\begin{frame}[c, fragile]{LSTM formulas}
  \includegraphics[height=6.5cm]{images/lstm-formulas.png}

  \small{image credit: Arun Mallya, from \url{http://arunmallya.github.io/writeups/nn/lstm/index.html#/}}
\end{frame}

\begin{frame}[t]{Variants: gated RNNs}
\begin{itemize}
\item gated RNNs: show different update rule as graph + formulas

\end{itemize}
\end{frame}

\begin{frame}[t]{Variants}
  \begin{itemize}
  \item LSTM, gated RNN, LSTM with peephole connections
  \item results are mainly similar \\
  $\implies$ LSTM architecture not ``necessary'' but may be more intuitive \\
  $\implies$ gate mechanism is the key
  \end{itemize}
\end{frame}

\begin{frame}[t]{Power of gate mechanism}
  \begin{itemize}
  \item LSTM can make variables \textit{internal}, just for further computation
  \item LSTM can extract features of current input and add them selectively to its state
  \item LSTM can selectively forget and remember features
  
  \item LSTM variables already have their meaning: \\
    less training and less variables needed
  \item LSTM weights can more easily be interpreted
  \item fewer gradient decay problems because information flows by default    
  \item easily optimizable $>>$ good optimizers
  \end{itemize}
\end{frame}

\begin{frame}[t]{Power of gate mechanism}
Examples of unit specializations from \url{http://karpathy.github.io/2015/05/21/rnn-effectiveness/} again
\end{frame}

\section{Optimization for Long-term dependencies}
\begin{frame}[t]{Optimization}
\begin{itemize}
\item Clipping gradients because cliffs common (exploding/vanishing gradients)
\item Regularize gradient to avoid decay/explosion
\end{itemize}
\end{frame}

\section{Explicit Memory}
\begin{frame}[t]{Explicit memory}
\begin{itemize}
\item implicit vs expicit memory
\item comparison to humans: how to dial, write report, program in Tensorflow
\item neural Turing machine: can learn to read from / write to memory cells
\item how to train: we need gradients, so use soft addressing with probability distribution
\item (alternative: hard addressing + reinforcement learning)
\item vector-valued cells for efficiency + content-based addressing: lyrics example: ``associative'' memory
\end{itemize}
\end{frame}

\begin{frame}[t]{Attention}
\begin{itemize}
\item generalized idea: attention mechanism: train network not to deal with whole data at once, but sequentially, changing its focus of attention
\item this is where RNNs come into computer vision
\item ???
\end{itemize}
\end{frame}

\begin{frame}[t]{End}
\begin{itemize}
\item nice example of application to end with 
\end{itemize}
\end{frame}

\begin{frame}[t]{Summary}
\begin{itemize}
\item ...
\end{itemize}
\end{frame}

\begin{frame}[t]{Sources / further reading}
\begin{itemize}
\item ...
\end{itemize}
\end{frame}



\end{document}
